<?php


/**
 * Fonctions associées au squelette de même nom, mitoyen à ce fichier.
 *
 * @plugin Subdivisions
 * @license GPL 
 * @author Vincnt CALLIES
 *
 * @package SPIP\Subdivisions\Fonctions
**/

if (!defined('_ECRIRE_INC_VERSION')) return;

/**
 * Filtre combien de formes disponibles par pays.
 *
 */
function filtre_combien_de_formes($v){
	// combien d'API (proposant une forme)
	$nbre_api = sql_countsel("spip_subdivisions_apis", "statut=" . sql_quote('publie'));
	// combien de formes (dans la BDD groupé par id_gis car plusieurs subdivisions peuvent avoir le même contour)
	$nbre_bdd = sql_countsel("spip_subdivisions_peuplements",'','id_gis');
	// différences
	return $nbre_api - $nbre_bdd;
}

/**
 * Filtre combien de formes disponibles par pays.
 *
 */
function filtre_ligne_pays($iso_pays){
	// vérification
	$iso_pays = strtoupper ($iso_pays);
	if (!preg_match('/^[A-Z]{2}$/', $iso_pays)) {
		return false;
	}

	// formes disponibles (par les API)
	$out = array();$iso = array();
	if ($apis = sql_allfetsel('id_subdivision_api,iso_moi', 'spip_subdivisions_apis', array('iso_moi LIKE ' . sql_quote($iso_pays.'%'), "statut=" . sql_quote('publie')))) {
		foreach ($apis as $api) {
			$out[] = $api['id_subdivision_api'];
			$iso[$api['id_subdivision_api']] = $api['iso_moi'];
		}
	}

	// formes présentes (dans la BDD)
	$in = array();
	if ($bds = sql_allfetsel('id_subdivision_api,id_peuplement', 'spip_subdivisions_peuplements', sql_in('id_subdivision_api', $out))) {
		foreach ($bds as $bd) {
			$in[] = $bd['id_subdivision_api'];
		}
	}
	
	// La difference (ce que l'on peut encore installer)
	$restants = array_diff($out, $in);
	$nbre_restant = count($restants);

	include_spip('inc/filtres');
	// Il n'y a pas grand chose à installer	
	if ($nbre_restant > 0 AND $nbre_restant < 10) {
		foreach ($restants as $restant) {
			$subdivision = sql_fetsel("id_subdivision,titre", "spip_subdivisions", "iso_moi=" . sql_quote($iso[$restant]));
			$texte .= '<li class="item" dir="ltr"><a href="' . 
				generer_action_auteur('subdivision_peupler', $subdivision['id_subdivision'] . "-definition", self()) .
				'" title="' . extraire_multi($subdivision['titre']) . '">' . $iso[$restant] . '</a></li>';
		}
	}
	

	include_spip('inc/presentation');
	if ($nbre_restant > 9) {
		$texte .= '<li class="item" dir="ltr">' .
			icone_verticale(_T('subdivision:donnees_installer_contours'),
				generer_action_auteur('subdivisions_peupler_pays', $iso_pays . "-*-definition", self()),
				'multipolygon-24.png',
				'import',
				'right'
			)
			. '</li>'
			. "<br class='nettoyeur' />";
		
	}
	return $texte;
}

?>